



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>这样入门asp.net core，如何</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">这样入门asp.net core，如何</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-21 21:22:13 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>本文章主要说明asp.net core的创建和简单使用。</p>
<h2>一、使用到的命令</h2>
<ul><li>dotnet new ：创建项目（解决方案，类库，单元测试等），如：<code>dotnet new web</code></li>
<li>dotnet add package 添加一个nuget的引用</li>
<li>dotnet test：运行测试</li>
<li>dotnet build：编译项目</li>
<li>dotnet sln add：将项目添加到解决方案</li>
<li>dotnet add reference：对此项目添加项目引用</li></ul>
<h2>二、建立空项目</h2>
<ul><li>在测试目录下运行 <code>dotnet new web -n baseWeb</code>，创建web项目，结果如下图所示：</li>
<li><img referrerpolicy="no-referrer"src="http://ov1e3fd5m.bkt.clouddn.com/netcore/simple-step-one.png" /></li>
<li>运行 <code>dotnet run</code>，即可运行此项目，此命令内部会执行<code>dotnet build</code>命令编译项目，然后运行，结果如下：</li>
<li><img referrerpolicy="no-referrer"src="http://ov1e3fd5m.bkt.clouddn.com/netcore/simple-step-two.png" /><br />说明：此命令是在sln（解决方案）文件所在目录运行的，所以增加了-p参数，用于指定启动指定的项目。</li></ul>
<h2>三、引入mvc</h2>
<ul><li>由于我们创建是一个空web项目，是没有mvc相关依赖包的，所以首先需要运行<code>dotnet add package Microsoft.AspNet.Mvc</code> 进行依赖包的安装</li>
<li>然后在StartUp类的ConfigureServices方法中添加如下代码：</li></ul>
<div>
<pre class="prettyprint linenums">public void ConfigureServices(IServiceCollection service){<br />
    service.AddMvc();<br />
    service.AddRouting();<br />
}</pre>
</div>
<p>上述添加此添加了Mvc，也添加了路由</p>
<ul><li>配置路由，还是在StartUp类中，其方法为Configure添加如下代码：</li></ul>
<div>
<pre class="prettyprint linenums">public void Configure(IApplicationBuilder app, IHostingEnvironment env)<br />
{<br />
    if (env.IsDevelopment())<br />
    {<br />
        app.UseDeveloperExceptionPage();<br />
    }

    //添加的代码<br />
    app.UseMvc(routers=&gt;{<br />
        routers.MapRoute("default", "{controller=Home}/{action=Index}/{id?}");<br />
    });

    app.Run(async (context) =&gt;<br />
    {<br />
        await context.Response.WriteAsync("Hello World!");<br />
    });<br />
}</pre>
</div>
<ul><li>对controller和view的创建<br />在创建controller时，没有找到完全好的 命令创建方法，所以使用的是手动创建文件，然后继承Controller类实现；而view是可以通过<code>dotnet new page</code>实现的，但也可以使用手动创建。文件结果如下：<br /><img referrerpolicy="no-referrer"src="http://ov1e3fd5m.bkt.clouddn.com/netcore/simple-step-thr.png" /></li>
<li>执行<code>dotnet run</code>运行，然后网页访问对就的地址即可<br /><img referrerpolicy="no-referrer"src="http://ov1e3fd5m.bkt.clouddn.com/netcore/simple-step-four.png" /></li></ul>
<h2>四、更换依赖注入为autofac</h2>
<p>aspnet core是自带了依赖注入功能的，就是StartUp类中ConfigureServices方法的IServiceCollection类型的形参。如果你想替换为autofac。请参考如下步骤</p>
<ul><li>安装autofac，以及acutofac的扩展类</p>
<ul><li>Autofac</li>
<li>Autofac.Extensions.DependencyInjection</li></ul></li>
<li>更改StartUp类中的configureSeervices方法</li></ul>
<div>
<pre class="prettyprint linenums">public IServiceProvider ConfigureServices(IServiceCollection service){<br />
    service.AddMvc();<br />
    service.AddRouting();<br />
    var containerBuilder = new ContainerBuilder();<br />
    containerBuilder.Populate(service);<br />
    containerBuilder.RegisterType&lt;Services.ProductService&gt;().As&lt;Services.IProductService&gt;();<br />
    var container = containerBuilder.Build();<br />
    return new AutofacServiceProvider(container);<br />
}</pre>
</div>
<ul><li>其中，我们更改了ConfigureServices方法的返回值，由void换成IServiceProvider；此返回为AutofacServiceProvider类的一个实例；在上述过程中，使用了continerBuilder.Populate方法将service(IServiceCollection的实例对象)注入到autofac中。</li>
<li>其中为了测试DI能力，我们创建一个IProductService的注入，并在Controller中使用，相关代码如下：
<ul><li>IProductService</li></ul></li></ul>
<div>
<pre class="prettyprint linenums">namespace baseWeb.Services<br />
{<br />
    public interface IProductService<br />
    {<br />
        int Get(int id);<br />
    }<br />
}</pre>
</div>
<ul><li>ProductService</li></ul>
<div>
<pre class="prettyprint linenums">using System.Collections.Generic;

namespace baseWeb.Services<br />
{<br />
    public class ProductService:IProductService<br />
    {<br />
        List&lt;int&gt; ls = new List&lt;int&gt;();

        public ProductService(){<br />
            for(var i=; i&lt;; i++){<br />
                ls.Add(i+);<br />
            }<br />
        }<br />
        public int Get(int id){<br />
            return ls[id];<br />
        }<br />
    }<br />
}</pre>
</div>
<ul><li>HomeController</li></ul>
<div>
<pre class="prettyprint linenums">using System;<br />
using System.Collections.Generic;<br />
using Microsoft.AspNetCore.Mvc;

namespace baseWeb.Controllers<br />
{<br />
    public class HomeController:Controller<br />
    {<br />
        private Services.IProductService productService;

        public HomeController(Services.IProductService productService){<br />
            this.productService = productService;<br />
        }

        public IActionResult Index(int id){<br />
            ViewData["value"] = this.productService.Get(id);<br />
            return View();<br />
        }<br />
    }<br />
}</pre>
</div>
<ul><li>运行结果如下：<br /><img referrerpolicy="no-referrer"src="http://ov1e3fd5m.bkt.clouddn.com/netcore/simple-step-five.png" /></li></ul>
<h2>五、加入单元测试</h2>
<p>在实际开发中，经常需要用到单元测试。.net core的单元测试也是如此的 so easy， fallow me。</p>
<ul><li>运行<code>dotnet new xunit -n baseWebTest</code>，即可创建一个以xunit为测试框架的单元测试项目</li>
<li>运行<code>dotnet add package Moq</code>，安装Moq模拟框架（此命令需要进入到baseWebTest项目文件夹后运行）</li>
<li>运行<code>dotnet add reference ../baseWeb/baseWeb.csproj</code>，将baseWeb项目引入到此项目中。</li>
<li>编写单元测试代码如下:</li></ul>
<div>
<pre class="prettyprint linenums">using System;<br />
using Xunit;<br />
using Moq;<br />
using baseWeb.Controllers;<br />
using baseWeb.Services;<br />
using Microsoft.AspNetCore.Mvc;

namespace basewebtest<br />
{<br />
    public class DemoTest<br />
    {<br />
        [Fact]<br />
        public void Test1()<br />
        {<br />
            var productServiceMock = new Mock&lt;IProductService&gt;();<br />
            productServiceMock.Setup(service=&gt;service.Get()).Returns((int id)=&gt;{<br />
                return id+;<br />
            });<br />
            var _controller = new HomeController(productServiceMock.Object);

            var result = _controller.Index();<br />
            var objectResult = Assert.IsType&lt;ViewResult&gt;(result);<br />
            var destResult = Assert.IsAssignableFrom&lt;int&gt;(objectResult.ViewData["value"]);<br />
            Assert.Equal(, destResult);<br />
        }<br />
    }<br />
}</pre>
</div>
<ul><li>运行<code>dotnet test -p ./baseWebtest/baseWebtest.csproj</code>即可，看到如下结果：</li>
<li><img referrerpolicy="no-referrer"src="http://ov1e3fd5m.bkt.clouddn.com/netcore/simple-step-six.png" /></li></ul>
<h2>六、其他</h2>
<ul><li>如果你是使用vscode编写，那么测试项目是可以在编译器中进行运行和调试的<br /><img referrerpolicy="no-referrer"src="http://ov1e3fd5m.bkt.clouddn.com/netcore/simple-step-notice.png" /></li>
<li><a href="https://files.cnblogs.com/files/cqhaibin/aspnetcore.rar" rel="external nofollow noreferrer">下载测试源码</a></li></ul>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/g8eojgmq.html">win10 开机黑屏只显示鼠标</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq1x6148.html">利用BMFont和NGUI制作字体集</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9plvo4q.html">MVC&period;Net&colon; 解决Attempted to access an unloaded appdomain的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/4952o4z9.html">文件输入流 FileInputStream类 文件输出流FileOutputStream  ---转载</a>
		</li>
						<li><a href="https://www.batexi.com/a/390z6e3q.html">Android自动化测试框架对比</a>
		</li>
						<li><a href="https://www.batexi.com/a/96oppk39.html">matlab 画框（三） 画框并保存图像</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rd5do78.html">js中的prototype和constructor</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnj440q.html">Android之使用HTTP协议的Get&sol;Post方式向服务器提交数据</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xgyg09.html">hdu 4672 Present Day&comma; Present Time 博弈论</a>
		</li>
						<li><a href="https://www.batexi.com/a/96o430j9.html">jQuery执行请求demo</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdp2vk8.html">一些static&lowbar;cast  const&lowbar;cast</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvw05zq.html">10个经典的 Java main 方法面试题</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvv665xq.html">Objextive-C几道小题目笔记</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2j51gl8.html">asp&period;net打印网页后自动关闭网页【无需插件】</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jxnjl8.html">Toy Storage POJ 2398</a>
		</li>
						<li><a href="https://www.batexi.com/a/90mxrpm8.html">shell&comma;python获取当前路径（脚本的当前路径） &lpar;aso项目记录&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1yyj5q.html">Attention模型</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnv6dgk8.html">Android应用开发-网络编程&lpar;一&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql1jg469.html">PPT模板中的&rdquo;书签&rdquo;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jmp0549.html">dp练习（4）&mdash;&mdash;过河卒</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qlj3k069.html">基于MT6752&sol;32平台 Android L版本驱动移植步骤</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdp4zy7q.html">hadoop 测试框架</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4zvkej9.html">【Android 应用开发】对Android体系结构的理解--后续会补充</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rgr7m48.html">IOS9关于搜索的认识和实现</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2jl31o8.html">The 14th tip of DB Query Analyzer</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kpgror9.html">Demo2</a>
			</li>
						<li><a href="https://www.batexi.com/a/8eylrmz9.html">js定义数组的方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxkmz208.html">getContext在谷歌浏览器中，使用时要先加载canvas对象，否则会提示&amp;&num;39&semi;getContext is null&amp;&num;39&semi;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv1m34xq.html">java实习面试题（阿里一面）</a>
			</li>
						<li><a href="https://www.batexi.com/a/90mx1p38.html">JSON 的含义？</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
